<bugID>356241<Summary>Duplicate the behavior of IE when setting Firefox as the default browser</Summary><Description>This applies to OS's prior to Vista

What I am seeing with IE:
1.a Admin user with no handlers under HKCU\Software\Classes with handlers under HKLM\Software\Classes
Take handlers under HKLM\Software\Classes

1.b Admin user with handlers under HKCU\Software\Classes AND HKLM\Software\Classes
Take handlers under HKLM\Software\Classes AND HKCU\Software\Classes

1.c Non-Admin user with handlers under HKCU\Software\Classes AND HKLM\Software\Classes
Take handlers under HKCU\Software\Classes

What I am seeing with Firefox:
2.a Admin user with no handlers under HKCU\Software\Classes with handlers under HKLM\Software\Classes
Take handlers under HKLM\Software\Classes

2.b Admin user with handlers under HKCU\Software\Classes AND HKLM\Software\Classes
Take handlers under HKCU\Software\Classes

2.c Non-Admin user with handlers under HKCU\Software\Classes AND HKLM\Software\Classes
Take handlers under HKCU\Software\Classes

So, 2.b is not the same as 1.b

Also, because of the way we set handlers we can end up with some of them being set under HKLM and some under HKCU for the admin user. If we pass false for aForAllUsers when calling OpenKeyForWriting we check for the existence of the key in HKCU and if it doesn't exist we fallback to HKLM. So, if it is found under HKCU we won't update HKLM.

http://lxr.mozilla.org/seamonkey/source/browser/components/shell/src/nsWindowsShellService.cpp#101</Description></bugID>